% Resumen en español
\chapter*{Resumen}

\begin{abstractEs}
	%% TODO: Resumen en español, 250-500 palabras.
  %.  For example, in a cluster of photography applications the usual behaviour would be to access the camera and file system APIs. If an application accessed the SMS API it would be different from what is common in that cluster and therefore tagged as an anomaly. Along with the scalability improvements, I also obtained information directly from the Google Play Store for building a ground truth similar to the real world that can be used to evaluate the machine learning algorithms used in the technique.

  En este trabajo fin de máster presento una nueva versión de la técnica conocida como CHABADA.\@ El objetivo de la técnica es la búsqueda de correlaciones entre implementation de aplicaciones de Android y lo que anuncian sobre ellas en la tienda de aplicaciones. Esta nueva versión se centra en mejorar la escalabilidad de la anterior implementation con el objetivo de ser capaz de ejecutar la técnica con un dataset proveniente de la base de datos Tacyt. Tacyt es una plataforma de aplicaciones de Android obtenidas por ElevenPaths, una subsidiaria de Telefónica. Dentro de la conferencia JNIC investigadores de España pueden acceder a la base de datos y realizar experimentos sobre ella. A partir de la plataforma generé un dataset de 700000+ aplicaciones para analizar. La técnica usa una combinación de procesamiento de lenguaje natural, clustering y análisis estático para crear clusters de aplicaciones relacionadas entre sí. Dentro de los clusters la técnica extrae el comportamiento común para las aplicaciones del mismo y puede detectar malware dentro del cluster. Un aplicación se considera maliciosa si presenta comportamiento que no es común dentro del cluster. Por ejemplo, dentro de un cluster de aplicaciones de fotografía el comportamiento habitual sería el de acceder a la camara del telefono y al sistema de ficheros. Si una aplicación accediera a la API de SMS tendría un comportamiento fuera de lo común dentro del cluster y por tanto se clasificaría como una anomalía. Junto con las mejoras a la escalabilidad también he obtenido información directamente de la tienda Google Play Store para construir una verdad cercana al mundo real y usar esa verdad para evaluar los algoritmos de aprendizaje que se usan en la técnica.
  
\end{abstractEs}

% Palabras clave en español
\begin{keywordsEs}
Android, detección de malware, análisis de descripciones, clustering
\end{keywordsEs}


% Resumen en inglés
\chapter*{Abstract}

\begin{abstractEn}
  %% TODO: Resumen en inglés, 250-500 palabras.

  %% XXX: How about this as abstract? I just copied the one I made for MadSESE
  %% XXX: It's not good. Too broad and there are parts that are either ToDo or discarded.
  %% TODO: This shit need rewording.

%% Checking Android application descriptions against the application implementation could lead to interesting findings whenever a given application actually implements the features declared in the description or if, on the contrary, it does more than what is written in the description.

%% By taking previous work in this line of research (Gorla, 2014) we run this approach on scale. Using the Tacyt database as input, we use Gorla’s technique (for now on CHABADA) to create bigger models that encode information about more applications in order to be able to better classify applications.

%% The training and classification of applications in CHABADA uses a pipeline of steps that further refine the data until we have clusters of applications by the topics found in the text descriptions and by the API methods executed by the implementation of the application.

%% From those clusters we classify the applications as honest or dishonest if the used API method used correspond to the topics in the cluster. For example, is expect for application in the cluster of “camera, photo, torch” to use the Camera API. It would be unexpected, and therefore it would be an outlier in the cluster, an application that uses the SMS API.

%% In this rework of CHABADA we are comparing different algorithms in certain parts of the pipeline, like in the part that extract the topics of the descriptions, and, for integrating the pipeline with Tacyt we are improving the scalability of the architecture in order to support the humongous amount of applications that Tacyt has on its own database.

%% In this thesis I present a new version of an existing technique known as CHABADA.\@ The main goal of the technique is to search for a correlation between Android applications implementation and what is advertised in the store description of the Application. This new version is focused in improving the scalability of the old implementation in order to be able to run the technique with a dataset coming from the Tacyt database. Tacyt is a platform of scraped Android applications obtained by ElevenPaths, a Telefonica company, that is accesible to researchers in the context of the JNIC conference. From this platform I generated a dataset of 700000+ applications to be analyzed. The technique uses a combination of natural language processing, clustering and static analysis for creating clusters of related applications by the topics found in their descriptions. From this clusters the technique extracts the common behavior of the applications and can detect malware in a dataset of applications. A malicious application is classified as such if they show a behavior that is not common for the cluster of applications. For example, in a cluster of photography applications the usual behaviour would be to access the camera and file system APIs. If an application accessed the SMS API it would be different from what is common in that cluster and therefore tagged as an anomaly. The new version of the technique addresses some of the scalability problems that the old implementation had but not all of them. These unresolved issues where caused by bugs and limitations in external dependencies of the implementation. Changing this components is not a trivial task since their replacements have to have scalability in mind. From the parts of the implementation that run without issues I obtained results that shown improvements in both ingestion and speed.

In this master thesis I present a new version of an existing technique known as CHABADA.\@ The goal of the technique is to search for a correlation between Android applications implementation and what is advertised in the store description of the Application. This new version is focused in improving the scalability of the old implementation in order to be able to run the technique with a dataset coming from the Tacyt database. Tacyt is a platform of scraped Android applications obtained by ElevenPaths, a Telefonica company, that is accessible to researchers in the context of the JNIC conference. From this platform I generated a dataset of 700000+ applications to be analyzed. The technique uses a combination of natural language processing, clustering and static analysis for creating clusters of related applications by the topics found in their descriptions. From this clusters the technique extracts the common behavior of the applications and can detect malware in a dataset of applications. A malicious application is classified as such if they show a behavior that is not common for the cluster of applications. For example, in a cluster of photography applications the usual behavior would be to access the camera and file system APIs. If an application accessed the SMS API it would be different from what is common in that cluster and therefore tagged as an anomaly. Along with the scalability improvements, I also obtained information directly from the Google Play Store for building a ground truth similar to the real world that can be used to evaluate the machine learning algorithms used in the technique.
  
% TODO: Change abstract because the last part is no longer true.
  
\end{abstractEn}

% Palabras clave en inglés
\begin{keywordsEn}
Android, malware detection, description analysis, clustering
\end{keywordsEn}


